<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglCommunicationManager.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_d89ec3ddd84898ed9313f7a84ea735df.html">communication</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglCommunicationManager.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglCommunicationManager_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLCOMMUNICATIONMANAGER_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLCOMMUNICATIONMANAGER_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &lt;unistd.h&gt;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#include  &lt;stdint.h&gt;</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCommunication_8hpp.html">tiglCommunication.hpp</a>&quot;</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglContainersSubgraph_8hpp.html">tiglContainersSubgraph.hpp</a>&quot;</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglUtils_8hpp.html">tiglUtils.hpp</a>&quot;</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"> * NAMESPACES</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment"> * TIGLCommunicationManager class</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> SUBGRAPH_TYPE&gt;</div>
<div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html">   84</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;{</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> SUBGRAPH_TYPE::MESSAGE_TYPE DATA_MESSAGE_TYPE;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="classTIGLCommunicationSysMessage.html">TIGLCommunicationSysMessage</a> <a class="code" href="classTIGLCommunicationSysMessage.html">SYS_MESSAGE_TYPE</a>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;   <span class="keyword">typedef</span> vector&lt;DATA_MESSAGE_TYPE&gt; DATA_MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> DATA_MESSAGE_BUF_TYPE::iterator MESSAGE_BUF_ITERATOR;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;   <span class="keyword">typedef</span> vector&lt;SYS_MESSAGE_TYPE&gt; SYS_MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> SUBGRAPH_TYPE::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> SUBGRAPH_TYPE::INDEX_ITERATOR INDEX_ITERATOR;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> SUBGRAPH_TYPE::MUTATION_MBUF MUTATION_MBUF;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;   <span class="keyword">typedef</span> vector&lt;DATA_MESSAGE_BUF_TYPE&gt;* MBUF_PTR;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   <span class="keyword">typedef</span> SYS_MESSAGE_BUF_TYPE* SYS_MBUF_PTR;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;   <span class="keyword">typedef</span> MUTATION_MBUF* MUTATION_MBUF_PTR;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> MUTATION_MBUF::iterator MUTATION_ITERATOR;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;   <span class="comment">//typedef vector&lt;DATA_MESSAGE_BUF_TYPE&gt;                  EXTERNAL_MESSAGE_BUF;</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   <span class="keyword">typedef</span> DATA_MESSAGE_BUF_TYPE EXTERNAL_MESSAGE_BUF;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;   <a class="code" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>();</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;   <a class="code" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>(SUBGRAPH_TYPE *dataPtr, uint_fast32_t devices, <span class="keywordtype">int</span> rank = 0);</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;   ~<a class="code" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>();</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="comment">    * attributes</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#aad508b38f058c54ba1ac037995be39b3">  124</a></span>&#160;   SUBGRAPH_TYPE *<a class="code" href="classTIGLCommunicationManager.html#aad508b38f058c54ba1ac037995be39b3">dataPtr</a>;</div>
<div class="line"><a name="l00126"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#af6fa8fbb6818efd2c72360f354fcd8c6">  126</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLCommunicationManager.html#af6fa8fbb6818efd2c72360f354fcd8c6">initFlag</a>;</div>
<div class="line"><a name="l00128"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a4ae7ac30bbb2d7938b2bed7b4a4f21db">  128</a></span>&#160;   int_fast32_t <a class="code" href="classTIGLCommunicationManager.html#a4ae7ac30bbb2d7938b2bed7b4a4f21db">numDevices</a>;</div>
<div class="line"><a name="l00130"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#ad4af56522c0cbc793788b38985e086c8">  130</a></span>&#160;   uint64_t <a class="code" href="classTIGLCommunicationManager.html#ad4af56522c0cbc793788b38985e086c8">totalNumVertices</a>;</div>
<div class="line"><a name="l00132"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#ac7a34f82443f2d7f9d360733e3612e71">  132</a></span>&#160;   uint_fast32_t *<a class="code" href="classTIGLCommunicationManager.html#ac7a34f82443f2d7f9d360733e3612e71">timeCountSS</a>;</div>
<div class="line"><a name="l00134"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a7f26b4bdfbe6ad5b50ecde994314dafc">  134</a></span>&#160;   int_fast32_t <a class="code" href="classTIGLCommunicationManager.html#a7f26b4bdfbe6ad5b50ecde994314dafc">rank</a>;</div>
<div class="line"><a name="l00136"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#aa984b9688cd64536c6901729a536b07e">  136</a></span>&#160;   MPI_Request txRequests[NONBLOCKING_TX_THREADS];</div>
<div class="line"><a name="l00138"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a7102a95cb3b26dfb0c3704184183cb6b">  138</a></span>&#160;   <span class="keywordtype">bool</span> txBusyRequestFlag[NONBLOCKING_TX_THREADS];</div>
<div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#ac73c7a6147bb9bf5922d1f19f3ca524e">  140</a></span>&#160;   uint8_t txBuffers[NONBLOCKING_TX_THREADS][MAX_MESSAGE_SIZE];</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;   MPI_Request *txCountRequests;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;   uint_fast32_t *numDevMessagesBuf;</div>
<div class="line"><a name="l00145"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a906895636bcf6765c145fee98f783a6a">  145</a></span>&#160;   uint_fast32_t *<a class="code" href="classTIGLCommunicationManager.html#a906895636bcf6765c145fee98f783a6a">dataTxCount</a>;</div>
<div class="line"><a name="l00147"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a3793829e7ef861f7b5b17860067ee48b">  147</a></span>&#160;   uint_fast32_t *<a class="code" href="classTIGLCommunicationManager.html#a3793829e7ef861f7b5b17860067ee48b">mutationTxCount</a>;</div>
<div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a75211a6169aaac4eed3d58bf01c82c76">  149</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLCommunicationManager.html#a75211a6169aaac4eed3d58bf01c82c76">sysTxCount</a>;</div>
<div class="line"><a name="l00151"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a96784692fde5caddb9e66d0a09e558ce">  151</a></span>&#160;   <a class="code" href="structTIGLCommunicationMessageDev.html">TIGLCommunicationMessageDev</a> *<a class="code" href="classTIGLCommunicationManager.html#a96784692fde5caddb9e66d0a09e558ce">devTxMessages</a>;</div>
<div class="line"><a name="l00153"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#aa8ffcfa91ccbfdfd960bb4d49b0a58d8">  153</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLCommunicationManager.html#aa8ffcfa91ccbfdfd960bb4d49b0a58d8">ssComputationEndFlag</a>;</div>
<div class="line"><a name="l00155"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#aa1078d0a68d9c673ac78b269a05afb5f">  155</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLCommunicationManager.html#aa1078d0a68d9c673ac78b269a05afb5f">ssTxActiveFlag</a>;</div>
<div class="line"><a name="l00157"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a9b958601eb31e864eadcc7894b1499dd">  157</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLCommunicationManager.html#a9b958601eb31e864eadcc7894b1499dd">ssRxActiveFlag</a>;</div>
<div class="line"><a name="l00159"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a2409da069a49ea13d88a1c9901b28006">  159</a></span>&#160;   int_fast32_t *<a class="code" href="classTIGLCommunicationManager.html#a2409da069a49ea13d88a1c9901b28006">rxDevMessageCount</a>;</div>
<div class="line"><a name="l00161"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a863e67876467738e18090713f98a43b3">  161</a></span>&#160;   int_fast32_t *<a class="code" href="classTIGLCommunicationManager.html#a863e67876467738e18090713f98a43b3">targetRxDevMessageCount</a>;</div>
<div class="line"><a name="l00163"></a><span class="lineno"><a class="line" href="classTIGLCommunicationManager.html#a4e09ccded269eb73471b10d609d64c4a">  163</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLCommunicationManager.html#a4e09ccded269eb73471b10d609d64c4a">txIdleTime</a>, rxIdleTime, computeIdleTime;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="comment">    * methods</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> MESSAGE_TYPE&gt;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;   <span class="keywordtype">void</span> bytes2Messages(uint8_t* rxBuf, uint_fast32_t messageSize, vector&lt;MESSAGE_TYPE&gt; &amp;messageBuf);</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;   uint_fast32_t messages2Bytes(DATA_MESSAGE_BUF_TYPE *messagePtr, uint8_t *outBuf);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;   <span class="keywordtype">void</span> processOneMessage(uint8_t *rxBuf, <span class="keywordtype">int</span> tag, uint_fast32_t messageSize, uint_fast32_t dev);</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;   <span class="keywordtype">void</span> countMessages(uint_fast32_t *devMessagesCount);</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;   <span class="keywordtype">bool</span> existDataMessages2Tx();</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;   <span class="keywordtype">bool</span> existSysMessages2Tx();</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;   <span class="keywordtype">bool</span> existMutationMessages2Tx();</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;   <span class="keywordtype">void</span> sendDataMessages(<span class="keywordtype">bool</span> flushBuffers = <span class="keyword">false</span>);</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;   <span class="keywordtype">void</span> sendMessagesSizes();</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;   <span class="keywordtype">void</span> waitAllTx();</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;   <span class="keywordtype">int</span> findTxSlot();</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;   <span class="keywordtype">bool</span> RecvNewMessages();</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> reset();</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> init(SUBGRAPH_TYPE *dPtr, uint_fast32_t devices = 1, uint_fast32_t devRank = 0);</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;   <span class="keywordtype">void</span> initSS();</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;   <span class="keywordtype">bool</span> isTxComplete();</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> endSS();</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;   <span class="keywordtype">void</span> continuousSendMessages();</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;   <span class="keywordtype">void</span> continuousRecvMessages();</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> printIdleTime();</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> setTimePtr(uint_fast32_t *timePtr);</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> setNumVertices(uint64_t numVertices);</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> isMultipleDevices();</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;   <span class="keywordtype">void</span> sendSysMessages();</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;   <span class="keywordtype">void</span> sendMutationMessages();</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;   <span class="keywordtype">void</span> sendInstMutationMessage(<span class="keywordtype">int</span> thread);</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;   <span class="keywordtype">void</span> taggedBcast(uint8_t *txBuf, uint_fast32_t bufSize, <span class="keywordtype">int</span> tag);</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;   <span class="keywordtype">bool</span> instRecvMutationMessages(<span class="keywordtype">int</span> dev);</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">int</span> getRank();</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;};</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCommunicationManagerImplementation_8hpp.html">tiglCommunicationManagerImplementation.hpp</a>&quot;</span></div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLCOMMUNICATIONMANAGER_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classTIGLCommunicationManager_html_ac7a34f82443f2d7f9d360733e3612e71"><div class="ttname"><a href="classTIGLCommunicationManager.html#ac7a34f82443f2d7f9d360733e3612e71">TIGLCommunicationManager::timeCountSS</a></div><div class="ttdeci">uint_fast32_t * timeCountSS</div><div class="ttdoc">pointer to the ss counter </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:132</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a2409da069a49ea13d88a1c9901b28006"><div class="ttname"><a href="classTIGLCommunicationManager.html#a2409da069a49ea13d88a1c9901b28006">TIGLCommunicationManager::rxDevMessageCount</a></div><div class="ttdeci">int_fast32_t * rxDevMessageCount</div><div class="ttdoc">holds the number of received messages from each device (incremented with each new message) ...</div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:159</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a96784692fde5caddb9e66d0a09e558ce"><div class="ttname"><a href="classTIGLCommunicationManager.html#a96784692fde5caddb9e66d0a09e558ce">TIGLCommunicationManager::devTxMessages</a></div><div class="ttdeci">TIGLCommunicationMessageDev * devTxMessages</div><div class="ttdoc">message counter for the device messages </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:151</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html"><div class="ttname"><a href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a></div><div class="ttdoc">Core communicator class definition. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:84</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_ad4af56522c0cbc793788b38985e086c8"><div class="ttname"><a href="classTIGLCommunicationManager.html#ad4af56522c0cbc793788b38985e086c8">TIGLCommunicationManager::totalNumVertices</a></div><div class="ttdeci">uint64_t totalNumVertices</div><div class="ttdoc">total number of vertices in all devices </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:130</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a4e09ccded269eb73471b10d609d64c4a"><div class="ttname"><a href="classTIGLCommunicationManager.html#a4e09ccded269eb73471b10d609d64c4a">TIGLCommunicationManager::txIdleTime</a></div><div class="ttdeci">uint_fast32_t txIdleTime</div><div class="ttdoc">profiling information for the processing tasks </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:163</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a906895636bcf6765c145fee98f783a6a"><div class="ttname"><a href="classTIGLCommunicationManager.html#a906895636bcf6765c145fee98f783a6a">TIGLCommunicationManager::dataTxCount</a></div><div class="ttdeci">uint_fast32_t * dataTxCount</div><div class="ttdoc">counter for data messages </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:145</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a75211a6169aaac4eed3d58bf01c82c76"><div class="ttname"><a href="classTIGLCommunicationManager.html#a75211a6169aaac4eed3d58bf01c82c76">TIGLCommunicationManager::sysTxCount</a></div><div class="ttdeci">uint_fast32_t sysTxCount</div><div class="ttdoc">counter for system messages </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:149</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a7f26b4bdfbe6ad5b50ecde994314dafc"><div class="ttname"><a href="classTIGLCommunicationManager.html#a7f26b4bdfbe6ad5b50ecde994314dafc">TIGLCommunicationManager::rank</a></div><div class="ttdeci">int_fast32_t rank</div><div class="ttdoc">MPI rank of the current device. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:134</div></div>
<div class="ttc" id="tiglCommunicationManagerImplementation_8hpp_html"><div class="ttname"><a href="tiglCommunicationManagerImplementation_8hpp.html">tiglCommunicationManagerImplementation.hpp</a></div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_aa8ffcfa91ccbfdfd960bb4d49b0a58d8"><div class="ttname"><a href="classTIGLCommunicationManager.html#aa8ffcfa91ccbfdfd960bb4d49b0a58d8">TIGLCommunicationManager::ssComputationEndFlag</a></div><div class="ttdeci">bool ssComputationEndFlag</div><div class="ttdoc">flag of the end of the SS execution (no more messages are generated) </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:153</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a863e67876467738e18090713f98a43b3"><div class="ttname"><a href="classTIGLCommunicationManager.html#a863e67876467738e18090713f98a43b3">TIGLCommunicationManager::targetRxDevMessageCount</a></div><div class="ttdeci">int_fast32_t * targetRxDevMessageCount</div><div class="ttdoc">holds the target number of messages from each device </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:161</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_aad508b38f058c54ba1ac037995be39b3"><div class="ttname"><a href="classTIGLCommunicationManager.html#aad508b38f058c54ba1ac037995be39b3">TIGLCommunicationManager::dataPtr</a></div><div class="ttdeci">SUBGRAPH_TYPE * dataPtr</div><div class="ttdoc">pointer to PregelDataContainer object that contains all message buffers </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:124</div></div>
<div class="ttc" id="tiglCommunication_8hpp_html"><div class="ttname"><a href="tiglCommunication_8hpp.html">tiglCommunication.hpp</a></div></div>
<div class="ttc" id="tiglUtils_8hpp_html"><div class="ttname"><a href="tiglUtils_8hpp.html">tiglUtils.hpp</a></div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_aa1078d0a68d9c673ac78b269a05afb5f"><div class="ttname"><a href="classTIGLCommunicationManager.html#aa1078d0a68d9c673ac78b269a05afb5f">TIGLCommunicationManager::ssTxActiveFlag</a></div><div class="ttdeci">bool ssTxActiveFlag</div><div class="ttdoc">flag of the end TX for current SS </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:155</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html">TIGLCommunicationSysMessage</a></div><div class="ttdoc">Core system message class definition. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:96</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a3793829e7ef861f7b5b17860067ee48b"><div class="ttname"><a href="classTIGLCommunicationManager.html#a3793829e7ef861f7b5b17860067ee48b">TIGLCommunicationManager::mutationTxCount</a></div><div class="ttdeci">uint_fast32_t * mutationTxCount</div><div class="ttdoc">counter for mutation messages </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:147</div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html">TIGLCommunicationMessageDev</a></div><div class="ttdoc">message container for TX/RX </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:116</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_af6fa8fbb6818efd2c72360f354fcd8c6"><div class="ttname"><a href="classTIGLCommunicationManager.html#af6fa8fbb6818efd2c72360f354fcd8c6">TIGLCommunicationManager::initFlag</a></div><div class="ttdeci">bool initFlag</div><div class="ttdoc">initlialization flag </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:126</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a9b958601eb31e864eadcc7894b1499dd"><div class="ttname"><a href="classTIGLCommunicationManager.html#a9b958601eb31e864eadcc7894b1499dd">TIGLCommunicationManager::ssRxActiveFlag</a></div><div class="ttdeci">bool ssRxActiveFlag</div><div class="ttdoc">flag of the end RX for current SS </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:157</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html_a4ae7ac30bbb2d7938b2bed7b4a4f21db"><div class="ttname"><a href="classTIGLCommunicationManager.html#a4ae7ac30bbb2d7938b2bed7b4a4f21db">TIGLCommunicationManager::numDevices</a></div><div class="ttdeci">int_fast32_t numDevices</div><div class="ttdoc">total number of devices </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:128</div></div>
<div class="ttc" id="tiglContainersSubgraph_8hpp_html"><div class="ttname"><a href="tiglContainersSubgraph_8hpp.html">tiglContainersSubgraph.hpp</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:51 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
